﻿using AsmodeeDigital.PlayReal.Plugin.Domain.Players;
using ProtoBuf;
using System;
using System.Collections.Generic;

namespace AsmodeeDigital.PlayReal.Plugin.Domain.GameState
{
    /// <summary>
    /// Game state of the game. Contains all events of a game
    /// </summary>
    [ProtoContract(), Serializable]
    public class GameStateBase
    {
        /// <summary>
        /// List of all events of a game (event sourcing)
        /// </summary>
        [ProtoMember(1)]
        public List<IEvent> Events { get; set; }

        /// <summary>
        /// List of ordered players (first in list will play first)
        /// </summary>
        [ProtoMember(2)]
        public List<int> NextPlayers { get; set; }

        /// <summary>
        /// List of players
        /// </summary>
        [ProtoMember(3)]
        public List<IPlayerSeat> PlayerSeats { get; set; }

        /// <summary>
        /// Check the game state data. If data are corrupter, send a DataCorruptedException
        /// </summary>
        public virtual void CheckGameState()
        {
            //int lastTime = 0;
            //foreach (IEvent eventGame in Events)
            //{
            //    if (!(eventGame.Time > lastTime))
            //        throw new DataCorruptedException();
            //}
        }
    }
}
