﻿using AsmodeeDigital.PlayReal.Plugin.Domain.GameState;
using ProtoBuf;
using System;
using System.Collections.Generic;

namespace AsmodeeDigital.PlayReal.Samples.Domain.GameState.Events
{
    /// <summary>
    /// Event which indicate that the dice are rolled
    /// </summary>
    [ProtoContract, Serializable]
    public class DiceRolled : IEvent
    {
        /// <summary>
        /// Player local ID
        /// </summary>
        [ProtoMember(1)]
        public int PlayerLocalID { get; set; }

        /// <summary>
        /// UTC time
        /// </summary>
        [ProtoMember(2)]
        public long Time { get; set; }

        /// <summary>
        /// List of index of all rolled Dice
        /// </summary>
        [ProtoMember(3)]
        public List<int> DiceIndicesRolled = new List<int>();

        public DiceRolled()
        {
        }

        public DiceRolled(int playerLocalID, List<int> diceIndicesRolled)
        {
            PlayerLocalID = playerLocalID;
            DiceIndicesRolled.AddRange(diceIndicesRolled);

            Time = DateTime.Now.Ticks;
        }
    }
}
